
%%%%%%%%%%%%%%       MAKROS        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%  Titelseite

#(define-markup-command (vorschub layout props amount) (number?)
  (interpret-markup layout props
  (markup #:with-dimensions (cons 0 0) (cons 0 amount) #:null)))


tr = ^\markup { \bold {+}}
st = ^\staccatissimo

%  Unterbalken geändert: statt 3 * 2 16-tel nun 2 * 3 16-tel
qbeam = {
  \set subdivideBeams = ##t
  \set Staff.beatLength = #(ly:make-moment 3 16)
  \set Staff.beatLength = #(ly:make-moment 3 8)
}
% Unterbalken gemäß Standard
nbeam = {
  \set Staff.beatLength = #(ly:make-moment 1 8)
  \set subdivideBeams = ##f
}
% Linien im Generalbass ein und ausschalten
lj = \set useBassFigureExtenders = ##t
ln = \set useBassFigureExtenders = ##f


% bei Verzierungen: Hälse kürzen, Hals nach unten, kleine Noten
sk =  { \once \override Stem #'length-fraction = #0.6 \once \override Stem #'direction = #DOWN \once \set fontSize = #-4   }
ska = { \once \override Stem #'length-fraction = #0.7 \once \override Stem #'direction = #DOWN \once \set fontSize = #-4   }
sku = { \once \override Stem #'length-fraction = #0.7 \once \override Stem #'direction = #UP \once \set fontSize = #-4   }
skn = { \once \override Stem #'length-fraction = #1 \once \override Stem #'direction = #DOWN \once \set fontSize = #-4   }
sn =     \override Stem #'length-fraction = #1  %normale Länge
% Nötig für weiße Notenköpfe
dua = \override NoteHead #'duration-log = #1
duo = \override NoteHead #'duration-log = #0


tr = ^\markup { \bold {+}}
pad =  { \once \override Script #'padding = #1.0 }
% kleine Noten
kl =  \set fontSize = #-4 
  
% normal große Noten
nm =   \set fontSize = #0

% bei Verzierungen: Hälse kürzen, Hals nach unten, kleine Noten
skd =  { \once \override Stem #'length-fraction = #0.6 \once \override Stem #'direction = #DOWN \once \set fontSize = #-3   }
skxd =  { \override Stem #'length-fraction = #0.4  \override Stem #'direction = #DOWN  \set fontSize = #-3   }
skad = { \once \override Stem #'length-fraction = #0.65 \once \override Stem #'direction = #DOWN \once \set fontSize = #-3   }
sknd = { \once \override Stem #'length-fraction = #1 \once \override Stem #'direction = #DOWN \once \set fontSize = #-3   }
sku = { \once \override Stem #'length-fraction = #0.6 \once \override Stem #'direction = #UP \once \set fontSize = #-3   }
skau = { \once \override Stem #'length-fraction = #0.8 \once \override Stem #'direction = #UP \once \set fontSize = #-3   }
sknu = { \once \override Stem #'length-fraction = #1 \once \override Stem #'direction = #UP \once \set fontSize = #-3   }

% Hotteterres Verzierungen
% pd = ^\ltoe 	% Porte de voix
% pu = \rtoe 	% 
tu = ^\markup { \musicglyph #"scripts.turn" } 
afterturn =  #'((moveto 1.4 .7)
          (lineto 2 .6)    
          (curveto 3.8 -0.4 3.8 1.6 2.8 1.0)
          )


trturn = \markup { 
  \combine 
  "+" 
  \path #0.28 #afterturn  
}

% Double Cadence coupée
dcc = \markup\concat {
  \musicglyph #"plus"
  \hspace #.2
  \override #'(filled . #t) 
  \path #0.08
  #'((moveto    0.00    1.00)
     (curveto   0.05    0.95   0.10   1.05   0.22   1.05)
     (curveto   0.35    1.05   0.50   0.85   0.70   0.85)
     (curveto   1.00    0.85   1.20   1.15   1.20   1.45)
     (curveto   1.20    1.60   1.10   1.80   0.95   1.80)
     (curveto   0.85    1.80   0.77   1.72   0.80   1.70)
     (curveto   0.82    1.67   0.85   1.70   0.90   1.70)
     (curveto   1.05    1.70   1.15   1.55   1.15   1.40)
     (curveto   1.15    1.20   1.00   1.00   0.70   1.00)
     (curveto   0.50    1.00   0.50   1.20   0.23   1.20)
     (curveto   0.10    1.20  -0.05   1.05   0.00   1.00)
     (closepath)) 
}


%  coulement
pd = \markup\concat {
      \override #'(filled . #t) 
      \hspace #0.2
      \override #'(thickness . 2.0)
      \draw-line #'(0.4 . 0.8)
      \hspace #-0.05
      \draw-line #'(-0.4 . 0.8)
    }
{

}

% porte de voix
pu = \markup\concat {
      \override #'(filled . #t) 
      \hspace #0.6
      \override #'(thickness . 2.0)
      \draw-line #'(-0.4 . 0.8)
      \hspace #-0.05
      \draw-line #'(0.4 . 0.8)
    }
{
    

}

%  accent

acc = \markup\concat {
      \hspace #2.0
      \override #'(filled . #t) 
      \override #'(thickness . 2.0)
      \draw-line #'(0.7 . 0.7)
  
}

% coulement et accent
pdac = \markup\concat {
      \override #'(filled . #t) 
      \override #'(thickness . 2.5)
      \draw-line #'(0.4 . 0.8)
      \hspace #-0.05
      \draw-line #'(-0.4 . 0.8)
      \hspace #0.6
      \override #'(filled . #t) 
      \override #'(thickness . 2.0)
      \draw-line #'(0.7 . 0.7)
    }
    
% Tour de chant (1. Auf der Note)
tdcc = \markup\concat {
  \override #'(filled . #f)  
 %  \override #'(line-join-style . miter)
  
  \hspace #-1.9
  \path #0.17
  #'((moveto 1.85 .8)
    ; (curveto 2.5 -1 3 1 3.3 0.6))
    (curveto 2 -0.2 3 0 3.05 0.8))
}

% Tour de chant (2. Nach der Note)
tdc = \markup\concat {
  \override #'(filled . #f)  
 %  \override #'(line-join-style . miter)
  
  \hspace #-0.6
  \path #0.17
  #'((moveto 1.85 .8)
    ; (curveto 2.5 -1 3 1 3.3 0.6))
    (curveto 2 -0.2 3 0 3.05 0.8))
}

% verkleinertes System
sstaffa = \with {
        	fontSize = #-3
        	\override StaffSymbol #'staff-space = #(magstep -3)
        	\override StaffSymbol #'thickness = #(magstep -3)
                % \override StaffGrouper #'staffgroup-staff-spacing #'basic-distance = #10
                 \override VerticalAxisGroup #'staff-staff-spacing = #'((basic-distance . 11))
}
sstaffb = \with {
        	fontSize = #-3
        	\override StaffSymbol #'staff-space = #(magstep -3)
        	\override StaffSymbol #'thickness = #(magstep -3)
                \override VerticalAxisGroup #'staff-staff-spacing = #'((basic-distance . 11))
}
sstaffc = \with {
        	fontSize = #-3
        	\override StaffSymbol #'staff-space = #(magstep -3)
        	\override StaffSymbol #'thickness = #(magstep -3)
                \override VerticalAxisGroup #'staff-staff-spacing = #'((basic-distance . 15))
}
      


%%%%%%%%%%  This provides joint rests
%%%%%%%%%%  for the voices of the right hand in the realisation
%%%%%%%%%%  of the figured bass
#(define (rest-score r)
   (let ((score 0)
         (yoff (ly:grob-property-data r 'Y-offset))
         (sp (ly:grob-property-data r 'staff-position)))
     (if (number? yoff)
         (set! score (+ score 2))
         (if (eq? yoff 'calculation-in-progress)
             (set! score (- score 3))))
     (and (number? sp)
          (<= 0 2 sp)
          (set! score (+ score 2))
          (set! score (- score (abs (- 1 sp)))))
     score))

#(define (merge-rests-on-positioning grob)
   (let* ((can-merge #f)
          (elts (ly:grob-object grob 'elements))
          (num-elts (and (ly:grob-array? elts)
                         (ly:grob-array-length elts)))
          (two-voice? (= num-elts 2)))
     (if two-voice?
         (let* ((v1-grob (ly:grob-array-ref elts 0))
                (v2-grob (ly:grob-array-ref elts 1))
                (v1-rest (ly:grob-object v1-grob 'rest))
                (v2-rest (ly:grob-object v2-grob 'rest)))
           (and
            (ly:grob? v1-rest)
            (ly:grob? v2-rest)
            (let* ((v1-duration-log (ly:grob-property v1-rest 'duration-log))
                   (v2-duration-log (ly:grob-property v2-rest 'duration-log))
                   (v1-dot (ly:grob-object v1-rest 'dot))
                   (v2-dot (ly:grob-object v2-rest 'dot))
                   (v1-dot-count (and (ly:grob? v1-dot)
                                      (ly:grob-property v1-dot 'dot-count -1)))
                   (v2-dot-count (and (ly:grob? v2-dot)
                                      (ly:grob-property v2-dot 'dot-count -1))))
              (set! can-merge
                    (and
                     (number? v1-duration-log)
                     (number? v2-duration-log)
                     (= v1-duration-log v2-duration-log)
                     (eq? v1-dot-count v2-dot-count)))
              (if can-merge
                  ;; keep the rest that looks best:
                  (let* ((keep-v1? (>= (rest-score v1-rest)
                                       (rest-score v2-rest)))
                         (rest-to-keep (if keep-v1? v1-rest v2-rest))
                         (dot-to-kill (if keep-v1? v2-dot v1-dot)))
                    ;; uncomment if you're curious of which rest was chosen:
                    ;;(ly:grob-set-property! v1-rest 'color green)
                    ;;(ly:grob-set-property! v2-rest 'color blue)
                    (ly:grob-suicide! (if keep-v1? v2-rest v1-rest))
                    (if (ly:grob? dot-to-kill)
                        (ly:grob-suicide! dot-to-kill))
                    (ly:grob-set-property! rest-to-keep 'direction 0)
                    (ly:rest::y-offset-callback rest-to-keep)))))))
     (if can-merge
         #t
         (ly:rest-collision::calc-positioning-done grob))))
